-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Dominique COLNET and Suzanne COLLIN - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
deferred class HASHABLE
--
-- Ancestor class for all hashable objects.
-- For example, hash_code is needed for DICTIONARY and for SET.
-- Many standard objects are HASHABLE (INTEGER, STRING, POINTER...)
--

feature

   hash_code: INTEGER is
         -- The hash-code value of `Current'.
      deferred
      ensure
         good_hash_value: Result >= 0
      end

end -- HASHABLE

