--          This file is part of SmartEiffel The GNU Eiffel Compiler.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Dominique COLNET and Suzanne COLLIN - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
-- SmartEiffel is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the Free
-- Software  Foundation;  either  version  2, or (at your option)  any  later
-- version. SmartEiffel is distributed in the hope that it will be useful,but
-- WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-- or  FITNESS FOR A PARTICULAR PURPOSE.   See the GNU General Public License
-- for  more  details.  You  should  have  received a copy of the GNU General
-- Public  License  along  with  SmartEiffel;  see the file COPYING.  If not,
-- write to the  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
-- Boston, MA 02111-1307, USA.
--
class ONCE_RESULT
   --
   -- Pseudo variable `Result' inside a once function.
   --

inherit ABSTRACT_RESULT

creation make

feature

   to_runnable(ct: E_TYPE): like Current is
      local
	 rf: RUN_FEATURE; rt1, rt2: E_TYPE
      do
         Result := Current
         rf := smart_eiffel.top_rf
         if run_feature = Void then
            run_feature := rf
         else
            rt1 := rf.result_type.run_type
            rt2 := run_feature.result_type.run_type
            if rt1.run_time_mark /= rt2.run_time_mark then
               error_handler.add_position(rt1.start_position)
               error_handler.add_position(rt2.start_position)
               run_feature.fe_vffd7
            end
         end
      end

   compile_to_c is
      do
         once_routine_pool.c_put_o_result(run_feature)
      end

   compile_to_jvm is
      do
	 once_routine_pool.jvm_result_load(run_feature)
      end

   jvm_assign_creation, jvm_assign is
      do
	 once_routine_pool.jvm_result_store(run_feature)
      end

feature {CREATE_TOOLS}

   c_variable_name: STRING is
      local
	 bf: E_FEATURE
      do
	 bf := run_feature.base_feature
         Result := once_routine_pool.o_result(bf)
      end

end -- ONCE_RESULT

