--          This file is part of SmartEiffel The GNU Eiffel Compiler.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Dominique COLNET and Suzanne COLLIN - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
-- SmartEiffel is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the Free
-- Software  Foundation;  either  version  2, or (at your option)  any  later
-- version. SmartEiffel is distributed in the hope that it will be useful,but
-- WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-- or  FITNESS FOR A PARTICULAR PURPOSE.   See the GNU General Public License
-- for  more  details.  You  should  have  received a copy of the GNU General
-- Public  License  along  with  SmartEiffel;  see the file COPYING.  If not,
-- write to the  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
-- Boston, MA 02111-1307, USA.
--
class ONCE_FUNCTION

inherit ONCE_ROUTINE

creation make

feature

   result_type: E_TYPE

feature

   make(n: like names
        fa: like arguments
        t: like result_type
        om: like obsolete_mark
        hc: like header_comment
        ra: like require_assertion
        lv: like local_vars
        rb: like routine_body) is
      require
         t /= Void
      do
         make_effective_routine(n,fa,om,hc,ra,lv,rb)
         result_type := t
      end

   to_run_feature(t: E_TYPE; fn: FEATURE_NAME): RUN_FEATURE_6 is
      do
         !!Result.make(t,fn,Current)
      end

feature {NONE}

   try_to_undefine_aux(fn: FEATURE_NAME
                       bc: BASE_CLASS): DEFERRED_ROUTINE is
      do
         !DEFERRED_FUNCTION!Result.from_effective(fn,arguments,
                                                  result_type,
                                                  require_assertion,
                                                  ensure_assertion,
                                                  bc)
      end

end -- ONCE_FUNCTION

